/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.game.logic;

import kinugasa.contents.resource.Storage;
import kinugasa.util.ArrayUtil;

/**
 * コマンドラインの引数を判定し、記録します.
 * <br>
 * KGFがサポートするコマンドライン引数の形式は以下の通りです。<br>
 * <li>フラグ型</li>
 * この形式は名前が宣言されると、フラグがONになります。<br>
 * 例：java Hoge piyo　→ piyo.isOn()=true
 * <br>
 * <li>プロパティ型</li>
 * この形式はキー＝値の形で、引数を送信します。必ずONになります。<br>
 * 例：java Hoge piyo=fuga　→　piyo.getValue()=fuga
 * <br>
 * これらの区別は1つのコマンドライン引数中にイコール"="が含まれているかどうかで
 * 判定されます。<br>
 * <br>
 * 使用可能なコマンドのうち、コマンドライン引数として送信されなかったものも、ストレージに追加されます。
 * そのようなコマンドは、isOnがfalseを返します。値はnullになります。<br>
 * <br>
 * @version 1.0.0 - 2013/04/27_17:08:39<br>
 * @author Dra0211<br>
 */
public final class CMDArgs extends Storage<CMDElement> {

	/** 唯一のインスタンスです. */
	private static final CMDArgs INSTANCE = new CMDArgs();

	/** シングルトンクラスです. */
	private CMDArgs() {
	}

	/**
	 * インスタンスを取得します.
	 * @return CMDArgsのインスタンスを返します。<br>
	 */
	public static CMDArgs getInstance() {
		return INSTANCE;
	}

	/**
	 * コマンドライン引数を判定し、追加します.
	 * @param args 起動時に送信されたコマンドライン引数をそのまま送信します。<br>
	 * @param keys コマンドライン引数として指定される可能性のある全ての”名前”を送信します。<br>
	 * フラグ型では、コマンドライン引数自体を、プロパティ型ではイコール"="の左側が
	 * 名前となります。<br>
	 */
	public void parse(String[] args, String... keys) {
		if (args.length == 0 || keys.length == 0) {
			return;
		}
		for (String arg : args) {
			if (arg.contains("=")) {
				String[] keyAndVal = arg.split("=");
				if (!ArrayUtil.contains(keys, keyAndVal[0])) {
					continue;
				}
				add(new CMDElement(keyAndVal[0], keyAndVal[1]));
			} else {
				if (!ArrayUtil.contains(keys, arg)) {
					continue;
				}
				add(new CMDElement(arg, "true"));
			}
		}
		for (String key : keys) {
			if (!contains(key)) {
				add(new CMDElement(key, null));
			}
		}
	}
}
